package com.css.simulation.resource.scene.mapper;

import api.common.pojo.param.scene.SceneDeleteParam;
import api.common.pojo.po.scene.ScenePackageSublistPO;
import api.common.pojo.vo.scene.ScenePackageSublistVO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Update;

import java.util.List;


@Mapper
public interface ScenePackageSublistMapper {

    void saveScenePackageSublist(ScenePackageSublistPO params);

    void saveScenePackageSublistAll(List<ScenePackageSublistPO> treeList);

    void deleteScenePackageSublist(String rootId);

    void deleteScenePackageSublistById(String sublistId);

    List<ScenePackageSublistVO> queryScenePackageSublistList(ScenePackageSublistPO params);

    //指标名查唯一
    List<ScenePackageSublistVO> queryBySublistName(ScenePackageSublistPO params);


    List<String> selectPackageIdById(SceneDeleteParam param);


    void deleteScenePackageSublistById(SceneDeleteParam param);

    @Update("update simulation.scene_package_sublist\n" +
            "set  scene_natural_ids =  replace(replace(replace(scene_natural_ids, concat(#{sceneZrId}, ','), ''), concat(',', #{sceneZrId}), ''),#{sceneZrId}, '')\n" +

            "        where\n" +
            "        is_deleted='0'\n" +
            "        <if test=\"sceneZrId != null and sceneZrId != ''\">\n" +
            "            and scene_natural_ids  like CONCAT('%',#{sceneZrId,jdbcType=VARCHAR},'%')\n" +
            "        </if>\n" +
            "        <if test=\"sceneJtId != null and sceneJtId != ''\">\n" +
            "            and scene_traffic_ids  like CONCAT('%',#{sceneJtId,jdbcType=VARCHAR},'%')\n" +
            "        </if>\n" +
            "        <if test=\"sceneBzId != null and sceneBzId != ''\">\n" +
            "            and scene_statue_ids  like CONCAT('%',#{sceneBzId,jdbcType=VARCHAR},'%')\n" +
            "        </if>\n" +
            "        <if test=\"sceneFhId != null and sceneFhId != ''\">\n" +
            "            and scene_generalization_ids  like CONCAT('%',#{sceneFhId,jdbcType=VARCHAR},'%')\n" +
            "        </if>")
    void updateSceneNaturalIdsBySceneId();
}
